#pragma once
//////////////////////////////////////////////////////////////////////
// SimpleRobot.h: interface for the Car class.
// -Kyoung Shin Park (2014 Spring)
//////////////////////////////////////////////////////////////////////
#include "moglclass.h"
#include "geometryPositionColor.h"
#include "shaders.h"
#include <glm/gtc/type_ptr.hpp>
#include <glm/gtc/matrix_transform.hpp>

namespace moglclass
{

class SimpleRobot
{
public:
	SimpleRobot();
	~SimpleRobot();
	void init();
    void draw(Program* p, glm::mat4& projection, glm::mat4& view, glm::mat4& model);
	bool update(float dt);

	void setTheta(float theta_) { theta = theta_; };
	void setPhi(float phi_) { phi = phi_; };
	void setPsi(float psi_) { psi = psi_; };

	void activate() { active = true; }
	void deactivate() { active = false; }
	bool isActive() { return active; }

protected:
	Program* p;
	Cylinder * base;
	Parallelepiped * arm[2];

	glm::mat4 baseTransform;
	glm::mat4 lowerArmTransform;
	glm::mat4 upperArmTransform;

	float theta;// body angle
	float phi;// lower arm angle
	float psi;// upper arm angle

	bool active;
};

} // moglclass namespace